/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: net_cons.c,v 1.4 2007/11/09 00:39:45 abe Exp abe $
 */

/* 
 *  ͥåȥͳ󥽡
 */

#include <stdarg.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/net_cons.h>

#ifdef USE_NET_CONS

/*
 *  ޥ
 */

/*  ͡β  */

#undef syslog
#undef serial_rea_dat
#undef serial_ctl_por

#define EOF		(-1)

/*  TELNET ץ */

#define TELNET_OPT_SE		(240)
#define TELNET_OPT_NOP		(241)
#define TELNET_OPT_DM		(242)
#define TELNET_OPT_BRK		(243)
#define TELNET_OPT_IP		(244)
#define TELNET_OPT_AO		(245)
#define TELNET_OPT_AYT		(246)
#define TELNET_OPT_EC		(247)
#define TELNET_OPT_EL		(248)
#define TELNET_OPT_GA		(249)
#define TELNET_OPT_SB		(250)
#define TELNET_OPT_WILL		(251)
#define TELNET_OPT_WONT		(252)
#define TELNET_OPT_DO		(253)
#define TELNET_OPT_DONT		(254)
#define TELNET_OPT_IAC		(255)

/*
 *  ѿ
 */

/*  TCP ɥХåե  */

UB net_cons_swbuf[NET_CONS_SWBUF_SIZE];
UB net_cons_rwbuf[NET_CONS_RWBUF_SIZE];

BOOL		connected	= FALSE;	/* ͥξ	*/
BOOL		wait_accept	= FALSE;	/* ³׵Ԥ	*/

#ifdef USE_TCP_EXTENTIONS

ID		net_cons_cepid	= TCP_CEP_NONE;
ID		net_cons_repid	= TCP_REP_NONE;

#else	/* of #ifdef USE_TCP_EXTENTIONS */

ID		net_cons_cepid	= NET_CONS_CEPID;
ID		net_cons_repid	= NET_CONS_REPID;

#endif	/* of #ifdef USE_TCP_EXTENTIONS */

#ifdef SUPPORT_INET4

T_IPV4EP	dst;

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

T_IPV6EP	dst;

#endif	/* of #ifdef SUPPORT_INET6 */

UB		*snd_buff	= NULL;
UB		*rcv_buff	= NULL;
UINT		snd_off		= 0;
UINT		rcv_off		= 0;
ER_UINT		snd_len		= 0;
ER_UINT		rcv_len		= 0;
UINT		net_ioctl	= IOCTL_NULL;

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_net_cons (ID cepid, FN fncd, VP p_parblk)
{
	ER	error = E_OK;
	SYSTIM	now;

	switch (fncd) {

	case TFN_TCP_ACP_CEP:
		get_tim(&now);

#ifdef USE_TCP_EXTENTIONS

		if (free_tcp_rep(net_cons_repid, (ER)p_parblk != E_DLT) != E_OK)
			syslog(LOG_NOTICE, "[NCS:%02d CBN] REP delete error: %s", net_cons_cepid, itron_strerror(error));

		if ((ER)p_parblk == E_OK) {
			syslog(LOG_NOTICE, "[NCS:%02d CBN] connected:  %6d, from: %s.%d",
			                   cepid, now / SYSTIM_HZ, IP2STR(NULL, &dst.ipaddr), dst.portno);
			connected = TRUE;
			}
		else if ((error = free_tcp_cep(net_cons_cepid)) != E_OK)
			syslog(LOG_NOTICE, "[NCS:00 CBN] CEP delete error: %s", itron_strerror(error));

#else	/* of #ifdef USE_TCP_EXTENTIONS*/

		if ((ER)p_parblk == E_OK) {
			syslog(LOG_NOTICE, "[NCS:%02d CBN] connected:  %6d, from: %s.%d",
			                   cepid, now / SYSTIM_HZ, IP2STR(NULL, &dst.ipaddr), dst.portno);
			connected = TRUE;
			}
		else
			syslog(LOG_NOTICE, "[NCS:%02d CBN] error: %s", itron_strerror((ER)p_parblk));

#endif	/* of #ifdef USE_TCP_EXTENTIONS*/

		snd_len = snd_off = rcv_len = rcv_off = 0;
		wait_accept = FALSE;
		break;

	case TFN_TCP_CLS_CEP:
	case TFN_TCP_RCV_BUF:
	case TFN_TCP_GET_BUF:
	case TFN_TCP_RCV_DAT:
	case TFN_TCP_SND_DAT:
	case TFN_TCP_CON_CEP:
	case TFN_TCP_SND_OOB:
	default:
		error = E_PAR;
		break;
		}
	return error;
	}

/*
 *  ХåեΥեå
 */

void
flush_snd_buff (void)
{
	ER_UINT	error;

	if (connected) {
		syscall(wai_sem(SEM_NET_CONS_SEND));
		if (snd_off > 0) {
			if ((error = tcp_snd_buf(net_cons_cepid, snd_off)) != E_OK && error != E_CLS)
				syslog(LOG_NOTICE, "[NCS:%02d SND] flush send error: %s",
				                   net_cons_cepid, itron_strerror(error));
			snd_len = snd_off = 0;
			}
		syscall(sig_sem(SEM_NET_CONS_SEND));
		}
	return;
	}

/*
 *  ʸ
 */

void
cons_putchar (ID portid, char ch)
{
	ER_UINT	error;

	if (connected) {
		if (ch == '\n' && (net_ioctl & IOCTL_CRLF) != 0)
			cons_putchar(portid, '\r');
		syscall(wai_sem(SEM_NET_CONS_SEND));
		if (snd_off >= snd_len) {
			if ((error = tcp_snd_buf(net_cons_cepid, snd_off)) != E_OK) {
				if (error != E_CLS)
					syslog(LOG_NOTICE, "[NCS:%02d SND] send buff error: %s",
					                   net_cons_cepid, itron_strerror(error));
				syscall(sig_sem(SEM_NET_CONS_SEND));
				return;
				}
			snd_off = 0;
			if ((snd_len = tcp_get_buf(net_cons_cepid, (VP*)(VP)&snd_buff, TMO_FEVR)) <= 0) {
				if (snd_len != E_CLS)
					syslog(LOG_NOTICE, "[NCS:%02d SND] get buff error: %s",
					                   net_cons_cepid, itron_strerror(snd_len));
				syscall(sig_sem(SEM_NET_CONS_SEND));
				return;
				}
			}
		snd_buff[snd_off ++] = ch;
		syscall(sig_sem(SEM_NET_CONS_SEND));
		}
	else
		serial_wri_dat(portid, &ch, sizeof(ch));
	}

/*
 *  ʸѴʤ
 */

static int
cons_getchar_raw (void)
{
	ER	error = E_OK;

	if (connected) {
		if (rcv_off >= rcv_len) {
			rcv_off = 0;
			if ((error = tcp_rel_buf(net_cons_cepid, rcv_len)) != E_OK) {
				if (error != E_CLS)
					syslog(LOG_NOTICE, "[NCS:%02d RCV] release buff error: %s",
					                   net_cons_cepid, itron_strerror(error));
				discon_net_cons();
				return EOF;
				}
			if ((rcv_len = tcp_rcv_buf(net_cons_cepid, (VP*)(VP)&rcv_buff, TMO_FEVR)) == 0) {
				discon_net_cons();
				return EOF;
				}
			else if (rcv_len < 0) {
				if (rcv_len != E_CLS)
					syslog(LOG_NOTICE, "[NCS:%02d RCV] recieve buff error: %s",
					                   net_cons_cepid, itron_strerror(rcv_len));
				discon_net_cons();
				return EOF;
				}
			}
		return rcv_buff[rcv_off ++];
		}
	else
		return EOF;
	}

/*
 *  ʸTELNET ץ򥹥åס
 */

int
cons_getchar (ID portid)
{
	T_SERIAL_RPOR	rpor;
	int		ch, req;
	UB		uch;

#ifndef USE_TCP_EXTENTIONS

	ER		error;

	if (!wait_accept && !connected) {
		wait_accept = TRUE;
		error = TCP_ACP_CEP(net_cons_cepid, net_cons_repid, &dst, TMO_NBLK);
#if 0
		syslog(LOG_NOTICE, "[NCS:%02d ACP] status: %s",net_cons_cepid, itron_strerror(error));
#endif
		if (error != E_WBLK)
			return EOF;
		}

#endif	/* of #ifndef USE_TCP_EXTENTIONS */

	while (TRUE) {
		if (connected) {
			while ((ch = cons_getchar_raw()) == TELNET_OPT_IAC || ch == '\0') {
				if (ch != '\0') {
					switch (ch = cons_getchar_raw()) {
					case TELNET_OPT_WILL:
					case TELNET_OPT_WONT:
					case TELNET_OPT_DO:
					case TELNET_OPT_DONT:
						req = cons_getchar_raw();
						break;
					case TELNET_OPT_SB:
						while ((ch = cons_getchar_raw()) != EOF && ch != TELNET_OPT_IAC) {
							if ((ch = cons_getchar_raw()) == EOF || ch == TELNET_OPT_SE)
								break;
							}
						break;
					default:
						break;
						}
					}
				}
			if ((net_ioctl & IOCTL_ECHO) != 0 && ch != EOF) {
				cons_putchar(portid, ch);
				flush_snd_buff();
				}
			return ch;
			}

		else if (serial_ref_por(portid, &rpor) == E_OK && rpor.reacnt > 0) {
			if (serial_rea_dat(portid, &uch, sizeof(uch)) > 0)
				return uch;
			else
				return EOF;
			}
		dly_tsk(100);
		}
	return EOF;
	}

/*
 *  ͥ
 */

ER
discon_net_cons (void)
{
	ER	error = E_OK;
	SYSTIM	now;

	if (connected) {
		syscall(wai_sem(SEM_NET_CONS_SEND));
		if (snd_off > 0) {
			if ((error = tcp_snd_buf(net_cons_cepid, snd_off)) != E_OK && error != E_CLS)
				syslog(LOG_NOTICE, "[NCS:%02d SND] send buff error: %s",
				                   net_cons_cepid, itron_strerror(error));
			}
		if ((error = tcp_sht_cep(net_cons_cepid)) != E_OK)
			syslog(LOG_NOTICE, "[NCS:%02d SHT] shutdown error: %s",
			                   net_cons_cepid, itron_strerror(error));
		if ((error = tcp_cls_cep(net_cons_cepid, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[NCS:%02d CLS] close error: %s",
			                   net_cons_cepid, itron_strerror(error));

#ifdef USE_TCP_EXTENTIONS

		if ((error = free_tcp_cep(net_cons_cepid)) != E_OK)
			syslog(LOG_NOTICE, "[NCS:00 EXT] CEP delete error: %s", itron_strerror(error));

#endif	/* of #ifdef USE_TCP_EXTENTIONS*/

		connected = FALSE;
		syscall(sig_sem(SEM_NET_CONS_SEND));
		get_tim(&now);
		syslog(LOG_NOTICE, "[NCS:%02d SND] disconnected:%5d, from: %s.%d",
		                   net_cons_cepid, now / SYSTIM_HZ, IP2STR(NULL, &dst.ipaddr), dst.portno);
		}
	return error;
	}

/*
 *  ꥢݡȤ
 */

ER
net_serial_ctl_por (ID portid, UINT ioctl)
{
	net_ioctl = ioctl;
	return serial_ctl_por(portid, ioctl);
	}

/*
 *  
 */

ER
net_syslog (UINT prio, const char *format, ...)
{
#ifdef SUPPORT_INET4
	T_IN4_ADDR	*addr;
#endif	/* of #ifdef SUPPORT_INET4 */

	LONGEST		val;
	SYSLOG		log;
	va_list		ap;
	char		padchar, *str;
	int		ch, width, longflag, left, i, c;

	if (connected) {
		syscall(wai_sem(SEM_NET_CONS_PRINTF));
		va_start(ap, format);
		while ((ch = *format ++) != '\0') {
			if (ch != '%') {		/* 񼰻ʳ */
				cons_putchar(CONSOLE_PORTID, (char)ch);
				continue;
				}

			width = longflag = 0;
			padchar = ' ';

			if (ch == '-') {		/* ͤ */
				format ++;
				left = -1;
				}
			else
				left = 1;

			if ((ch = *format ++) == '0') {	/* ̷ 0 */
				padchar = '0';
				ch = *format ++;
				}

			while ('0' <= ch && ch <= '9') {	/*  */
				width = width * 10 + ch - '0';
				ch = *format ++;
				}

			while (ch == 'l') {		/* long (long) λ */
				longflag ++;
				ch = *format ++;
				}

			switch (ch) {
			case 'd':
				val = GET_ARG(ap, longflag);
				if (val >= 0)
					cons_putnumber(CONSOLE_PORTID,  val, 10, radhex, width * left, FALSE, padchar);
				else
					cons_putnumber(CONSOLE_PORTID, -val, 10, radhex, width * left, TRUE, padchar);
				break;

			case 'u':
				val = GET_ARG(ap, longflag);
				cons_putnumber(CONSOLE_PORTID, val, 10, radhex, width * left, FALSE, padchar);
				break;

			case 'x':
				val = GET_ARG(ap, longflag);
				cons_putnumber(CONSOLE_PORTID, val, 16, radhex, width * left, FALSE, padchar);
				break;

			case 'X':
				val = GET_ARG(ap, longflag);
				cons_putnumber(CONSOLE_PORTID, val, 16, radHEX, width * left, FALSE, padchar);
				break;

			case 'c':
				ch = va_arg(ap, int);
				cons_putchar(CONSOLE_PORTID, (char)ch);
				break;

			case 's':
				str = va_arg(ap, char*);
				while ((ch = *str ++) != '\0') {
					cons_putchar(CONSOLE_PORTID, (char)ch);
					width --;
					}
				while (width -- > 0)
					cons_putchar(CONSOLE_PORTID, ' ');
				break;

			case 'I':

#ifdef SUPPORT_INET4

				addr = va_arg(ap, T_IN4_ADDR*);
				put_ipv4addr(CONSOLE_PORTID, addr, width);

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

				str = va_arg(ap, char*);
				put_ipv6addr(CONSOLE_PORTID, (T_IN6_ADDR *)str, width);

#endif	/* of #ifdef SUPPORT_INET6 */

				break;

			case 'M':
				str = va_arg(ap, char*);
				put_macaddr(CONSOLE_PORTID, str, width);
				break;

			case '%':
				cons_putchar(CONSOLE_PORTID, '%');
				break;

			case '0':
				format --;
				break;

			default:
				break;
				}

			}
		va_end(ap);
		cons_putchar(CONSOLE_PORTID, '\n');
		flush_snd_buff();
		syscall(sig_sem(SEM_NET_CONS_PRINTF));
		return E_OK;
		}
	else {
		log.logtype = LOG_TYPE_COMMENT;
		log.loginfo[0] = (VP_INT) format;
		i = 1;
		va_start(ap, format);

		while ((c = *format++) != '\0' && i < TMAX_LOGINFO) {
			if (c != '%') {
				continue;
				}

			c = *format++;
			while ('0' <= c && c <= '9') {
				c = *format++;
				}
			switch (c) {
			case 'd':
				log.loginfo[i++] = (VP_INT) va_arg(ap, int);
				break;
			case 'u':
			case 'x':
			case 'X':
				log.loginfo[i++] = (VP_INT) va_arg(ap, unsigned int);
				break;
			case 'p':
				log.loginfo[i++] = (VP_INT) va_arg(ap, void *);
				break;
			case 'c':
				log.loginfo[i++] = (VP_INT) va_arg(ap, int);
				break;
			case 's':
				log.loginfo[i++] = (VP_INT) va_arg(ap, const char *);
				break;
			case '\0':
				format--;
				break;
			default:
				break;
				}
			}
		va_end(ap);
		return(vwri_log(prio, &log));
		}
	}

#ifdef USE_TCP_EXTENTIONS

/*
 *  get_tcp_rep -- TCP ո롣
 */

static ER
get_tcp_rep (ID *repid)
{
	ID		tskid;
	T_TCP_CREP	crep;

	get_tid(&tskid);

	crep.repatr = 0;
	crep.myaddr.portno = 23;

#ifdef SUPPORT_INET4
	crep.myaddr.ipaddr = IPV4_ADDRANY;
#endif

#ifdef SUPPORT_INET6
	memcpy(&crep.myaddr.ipaddr, &ipv6_addrany, sizeof(T_IN6_ADDR));
#endif

	return alloc_tcp_rep(repid, tskid, &crep);
	}

/*
 *  get_tcp_cep -- TCP ̿ü롣
 */

static ER
get_tcp_cep (ID *cepid)
{
	ID		tskid;
	T_TCP_CCEP	ccep;

	get_tid(&tskid);

	ccep.cepatr = 0;
	ccep.sbufsz = NET_CONS_SWBUF_SIZE;
	ccep.rbufsz = NET_CONS_RWBUF_SIZE;
	ccep.callback = (FP)callback_nblk_net_cons;

#ifdef TCP_CFG_SWBUF_CSAVE
	ccep.sbuf = NADR;
#else
	ccep.sbuf = net_cons_swbuf;
#endif
#ifdef TCP_CFG_RWBUF_CSAVE
	ccep.rbuf = NADR;
#else
	ccep.rbuf = net_cons_rwbuf;
#endif

	return alloc_tcp_cep(cepid, tskid, &ccep);
	}

/*
 *  ͥåȥ󥽡뵯ư
 */

void
wup_net_cons (void)
{
	ER	error;

	if ((error = get_tcp_cep (&net_cons_cepid)) != E_OK)
		syslog(LOG_NOTICE, "[NCS:00 EXT] CEP create error: %s", itron_strerror(error));
	else if ((error = get_tcp_rep (&net_cons_repid)) != E_OK) {
		syslog(LOG_NOTICE, "[NCS:%02d EXT] REP create error: %s", net_cons_cepid, itron_strerror(error));
		free_tcp_cep(net_cons_cepid);
		}
	else {
		if ((error = TCP_ACP_CEP(net_cons_cepid, net_cons_repid, &dst, TMO_NBLK)) == E_WBLK)
			wait_accept = TRUE;
		else {
			if (error != E_DLT)
				syslog(LOG_NOTICE, "[NCS:%02d ACP] status: %s",net_cons_cepid, itron_strerror(error));
			if ((error = free_tcp_rep(net_cons_repid, error != E_DLT)) != E_OK)
				syslog(LOG_NOTICE, "[NCS:%02d EXT] REP delete error: %s",
				                   net_cons_cepid, itron_strerror(error));
			else if ((error = free_tcp_cep(net_cons_cepid)) != E_OK)
				syslog(LOG_NOTICE, "[NCS:00 EXT] CEP delete error: %s", itron_strerror(error));
			}
		}
	}

#endif	/* of #ifdef USE_TCP_EXTENTIONS */

#endif	/* of #ifdef USE_NET_CONS */
